# Note: Remove when a new release is created with the kotlin rules
[semgrep]
  description = "My custom ruleset for semgrep"
  targetdir = "/sgrules"
  timeout = 60

  [[semgrep.passthrough]]
    type  = "raw"
    target = "insecure.yml"
    value = """
rules:
  - id: "kotlin_random_rule-PseudoRandom"
    languages:
      - "kotlin"
    message: |
      The use of a predictable random value can lead to vulnerabilities when used in certain security
      critical contexts. A quick fix could be to replace the use of java.util.Random with something
      stronger, such as java.security.SecureRandom
    severity: "WARNING"
    metadata:
      shortDescription: "Use of insufficiently random values"
      category: "security"
      cwe: "CWE-330"
      owasp:
        - "A3:2017-Sensitive Data Exposure"
        - "A02:2021-Cryptographic Failures"
      technology:
        - "java"
      security-severity: "MEDIUM"

    patterns:
      - pattern-either:
          - pattern: |
              val $R: java.util.Random = java.util.Random()
              ...
              $R.$METHOD(...)
          - pattern: "($R: java.util.Random).$METHOD(...)"
          - pattern: "java.util.Random().$METHOD(...)"
          - pattern: "org.apache.commons.lang.math.RandomUtils.$METHOD(...)"
          - pattern: "org.apache.commons.lang.RandomStringUtils.$METHOD(...)"
      - metavariable-regex:
          metavariable: "$METHOD"
          regex: "^(next|random)"
"""